/*
	GGAME.CPP - The game generating function of Ohadi Lipski's Mines.
	Programmed by Shlomi Fish.
	Finished:
		June 1st 1994 "  "
*/

#ifndef __STDLIB_H
#include <stdlib.h>
#endif
#ifndef __DOS_H
#include <dos.h>
#endif
#ifndef __STDIO_H
#include <stdio.h>
#endif
#ifndef __GRAPHICS_H
#include <graphics.h>
#endif
#ifndef __SVGA256_H
#include <svga256.h>
#endif
#ifndef __IO_H
#include <io.h>
#ENDIF
#ifndef __FCNTL_H
#include <fcntl.h>
#endif
#ifndef __STAT_H
#include <sys\stat.h>
#endif
#ifndef __CONIO_H
#include <conio.h>
#endif
#ifndef __GGAME_H
#include <ggame.h>
#endif

enum cell_type {RegClose=0, MineClose=1, RegOpen=2, RegMarked=3, MineMarked=4};

unsigned X, Y, Number;
char field[80][60];
unsigned curnum;

const unsigned SVGA_RED = 39;
const unsigned cell_x = 14;
const unsigned cell_y = 13;
typedef char cell_image[214];

char clearm[3502];


inline void putcell(unsigned a, unsigned b, char * cell, int mode)
{
	putimage(a*cell_x, b*cell_y, (void*)cell, mode);
}

void discover_cell(unsigned cursx, unsigned cursy, int original)
{
	unsigned Nmines=0;
	int a, b;
	field[cursx][cursy] = RegOpen;
	curnum--;
	for(a=-1+(cursx==0);a<2-(cursx==X-1);a++)
		for(b=-1+(cursy==0);b<2-(cursy==Y-1);b++)
			if((field[cursx+a][cursy+b]==MineClose)||(field[cursx+a][cursy+b]==MineMarked))
				Nmines++; // is a mine
	if(Nmines==0)
	{
		putcell(cursx,cursy, opn[0], COPY_PUT);
		if (original) putcell(cursx,cursy,opencurs, XOR_PUT);
		for(a=-1+(cursx==0);a<(2-(cursx==X-1));a++)
			for(b=-1+(cursy==0);b<(2-(cursy==Y-1));b++)
			{
				if(field[cursx+a][cursy+b] ==	RegClose)
					discover_cell(cursx+a, cursy+b, 0);
			}
	}
	else // not a no-mines-around block
	{
		putcell(cursx,cursy,opn[Nmines],COPY_PUT);
		if (original) putcell(cursx,cursy,opencurs, XOR_PUT);
	}
}

void mines_game(unsigned _x, unsigned _y, unsigned _n)
{
	unsigned a, b, win_lose=1;
	unsigned cursx, cursy, mines_left = _n;
	char mmessage[20], mmclear[1000], ms[30];
	X = _x; Y = _y; Number = _n;
	// Initialization of screen
	cleardevice();
	setusercharsize(5,12,5,12);
	settextstyle(EUROPEAN_FONT, HORIZ_DIR, 0);
	sprintf(mmessage, "Mines Left: %i", Number);
	getimage(0,0,textwidth(mmessage+11), textheight(mmessage), (void*)clearm);
	setcolor(39);
	outtextxy(0, 300, mmessage);
	// Initialization of field
	for(a=0;a<X;a++)
		for(b=0;b<Y;b++)
		{
			putcell(a,b,clos, COPY_PUT);
			field[a][b] = RegClose;
	}
	setcolor(20);
	line(X*cell_x,0,X*cell_x,Y*cell_y);
	line(0,Y*cell_y,X*cell_x,Y*cell_y);
	setcolor(39);
	for(a=0;a<Number;a++)
	{
		do {
			cursx = random(X);cursy=random(Y);
		} while(field[cursx][cursy]);
		field[cursx][cursy] = MineClose;
	}
	cursx = 0;cursy = 0;curnum = X*Y-Number;
	// put first cursor
	putcell(cursx, cursy, closcurs, XOR_PUT);
	while(curnum > 0)
	{
		while (((a=getch()) != 13) && (a != 'm')) // movement
		{
			if (a==0)
			{
				a = getch();
				if ((a == 72)||(a==80)||(a==75)||(a==77))
				{
					if (field[cursx][cursy]==RegOpen) putcell(cursx,cursy,opencurs, XOR_PUT);
					else putcell(cursx,cursy,closcurs, XOR_PUT);
					switch(a)
					{
						case 72: if (cursy!=0) cursy--; break;
						case 80: if (cursy!=Y-1) cursy++; break;
						case 75: if (cursx!=0) cursx--; break;
						case 77: if (cursx!=X-1) cursx++; break;
					}
					if (field[cursx][cursy]==RegOpen) putcell(cursx,cursy,opencurs, XOR_PUT);
					else putcell(cursx,cursy,closcurs, XOR_PUT);
				}
			}
		}
		if(a == 13) // Uncover a block
		{
			if(field[cursx][cursy] == MineClose)
			{
				outtextxy(10, 200, "You uncovered a mine!\nGame Over");
				win_lose = 0;
				/*
				  Uncovering all procedure.
				*/
				getch();
				break;
			}
			if(field[cursx][cursy] >= RegMarked)
			{
				sound(440);delay(300);nosound(); // make a beep
			}
			if(field[cursx][cursy] == RegClose)
			{
				discover_cell(cursx, cursy, 1); // calls the function to uncover the block (and perhaps several others)
			}
		}
		else if(a == 'm') // mark or unmark
		{
			if (field[cursx][cursy] <= MineClose)
			{
				if (mines_left)
				{
					putcell(cursx,cursy,mark,COPY_PUT);
					putcell(cursx,cursy,closcurs,XOR_PUT);
					field[cursx][cursy]+=3;
					mines_left--;
					sprintf(mmessage, "Mines Left: %i", mines_left);
					putimage(textwidth("Mines Left:"), 300, (void*)clearm, COPY_PUT);
					outtextxy(0, 300, mmessage);
				}
				else {
					sound(440);delay(300);nosound(); // make a beep
				}
			}
			else if (field[cursx][cursy] >= RegMarked)
			{
				putcell(cursx,cursy,clos,COPY_PUT);
				putcell(cursx,cursy,closcurs,XOR_PUT);
				field[cursx][cursy]-=3;
				mines_left++;
				sprintf(mmessage, "Mines Left: %i", mines_left);
				putimage(textwidth("Mines Left:"),300, (void*)clearm, COPY_PUT);
				outtextxy(0, 300, mmessage);
			}
		}
	}
	// end
	if (win_lose)
	{
		setcolor(35);
		outtextxy(10,200,"You Won!!");getch();
	}
}

/*void fget_image(char * fname, char * image)
{
	char ch;
	ifstream i;
	i.open(fname, ios::nocreate);
	while (i.get(ch)) *(image++) = ch;
	i.close();
}*/


