#ifndef __GRAPHICS_H
#include <graphics.h>
#endif
#ifndef __SVGA256_H
#include <svga256.h>
#endif
#ifndef __IO_H
#include <io.h>
#endif
#ifndef __FCNTL_H
#include <fcntl.h>
#endif
#ifndef __STAT_H
#include <\sys\stat.h>
#endif
#include <strstream.h>
#ifndef __IOMANIP_H
#include <iomanip.h>
#endif
#ifndef __STDIO_H
#include <stdio.h>
#endif
#ifndef __GGAME_H
#include <ggame.h>
#endif
#ifndef __STRING_H
#include <string.h>
#endif

int return0() {return 0;}

unsigned modes[10][3], modes_N;

const unsigned maxX = 40, maxY = 20, maxNmines = 300;


int menu(unsigned number, char * headline, char * listing, char * keys)
{
	unsigned a, b, str_start, maxlen=0, x2, y1 ,y2;
	char ch;
	setusercharsize(3,2,3,2);
	setcolor(30);
	settextstyle(EUROPEAN_FONT, HORIZ_DIR, 0);
	outtextxy((640-textwidth(headline))>>1,10, headline);
	moveto(50,30+textheight(headline));
	y1 = 25+textheight(headline);
	setusercharsize(2,3,2,3);
	settextstyle(EUROPEAN_FONT, HORIZ_DIR, 0);
	for(a=0,b=0,str_start=0;a<number;a++)
	{
		while(listing[b] != '\x00')
			b++;
		b++;
		outtext(&listing[str_start]);
		moveto(50, gety()+textheight(&listing[str_start])+20);
		if(textwidth(&listing[str_start])>maxlen)
			maxlen = textwidth(&listing[str_start]);
		str_start = b;
	}
	x2 = 55+maxlen; y2 = y1+textheight(listing)+15;
	setcolor(56);
	rectangle(45, y1, x2, y2);
	a = 0;
	while((ch = getch()) != 13)
	{
		if(ch==0)
		{
			ch = getch();
			switch(ch)
			{
				case 80:
				b = a + 1 - number*(a==number-1);
				setcolor(0);
				rectangle(45,y1,x2,y2);
				y1 += (textheight(listing)+20)*(b-a);
				y2 += (textheight(listing)+20)*(b-a);
				setcolor(56);
				rectangle(45,y1,x2,y2);
				a = b;
				break;
				case 72:
				b = a - 1 + number*(a==0);
				setcolor(0);
				rectangle(45,y1,x2,y2);
				y1 += (textheight(listing)+20)*(b-a);
				y2 += (textheight(listing)+20)*(b-a);
				setcolor(56);
				rectangle(45,y1,x2,y2);
				a = b;
			}
		};
		for(b=0;b<number;b++)
			if (ch == keys[b])
				return keys[b];
	}
	return keys[a];
}

/*void write_mode_menus(char * string)
{
	ostrstream s(string,200);
	for(int a=0;a<modes_N;a++)
	{
		if (modes[a][0]==0)
			break;
		s << (a%10) << ". ";
		if (a==0) s << "Windows' Easy";
		else if (a==1) s << "Windows' Medium";
		else if (a==2) s << "Windows' Hard";
		s << " - " << modes[a][0] << "*" << modes[a][1] << "*" << modes[a][2] << '\x00';
	}
	s << "N. New mode" << '\x00' << "D. Delete a mode" << '\x00';
}*/

void write_mode_menus(char * string)
{
	char temp_s[100], mode_name[20];
	for(int a=0;a<modes_N;a++)
	{
		if (modes[a][0]==0)
			break;
		if (a==0) strcpy(mode_name, "Windows' Easy");
		else if (a==1) strcpy(mode_name, "Windows' Medium");
		else if (a==2) strcpy(mode_name, "Windows' Hard");
		else strcpy(mode_name, "");
		sprintf(temp_s, "%i. %s - %i*%i*%i", (a+1)%10, mode_name, modes[a][0], modes[a][1], modes[a][2]);
		strcpy(string, temp_s);
		string += strlen(string); // advance the pointer to next mode title.
	}
	strcat(string, "N. New mode");
	string+=strlen("N. New mode");
	strcat(string, "D. Delete a mode");
}

/*void high_scores(unsigned mode)
{
	cleardevice();
	ostrstream st;
	char t[1000], * fname;
	st << modes[mode][0] << 'x' << modes[mode][1] << 'x' << modes[mode][2] << ".mhs"<< '\x00';
	fname = st.str();
	char e[10][100], c;
	unsigned m[10], s[10];
	istrstream i(t);
	int a = open(fname, O_RDONLY|O_BINARY);
	if	((a<0))
	{
		outtextxy(0,30,"High scores file does not exist.\nPress any key to return to the main menu.");
		getch();
	}
	else if (filelength(a)>1000)
	{
		outtextxy(0,30,"High scores file is not valid.\nPress any key to return to the main menu.");
		close(a);
		remove(fname);
		getch();
	}
	else {
		read(a, (void*)t, filelength(a));
		close(a);
		for(a=0;a<10;a++)
		{
			i>>e[a];
			if (e[a][0] == 214) break;
			i >> m[a] >> c >> s[a];
		}
		setusercharsize(3,2,3,2);
		settextstyle(TRIPLEX_FONT, HORIZ_DIR,0);
		settextjustify(1,2);
		moveto(320,0);
		outtext("High Scores");
		setusercharsize(1,1,1,1);
		settextstyle(TRIPLEX_FONT, HORIZ_DIR,0);
		settextjustify(LEFT_TEXT,2);
		moveto(10,50);
		for(a=0;a<10,e[a][0] != 214; a++)
		{
			settextjustify(LEFT_TEXT,2);
			cout << a << ". " << setw(30) << e[a] << m[a] << ':' << s[a] << '\n';
		}
		getch();
	}
}*/


int main()
{
	int a, b=SVGA640x480x256, X, Y, N, curmode, number;
	a = installuserdriver("svga256",return0);
	initgraph(&a,&b,"c:\\tc\\bgi");
	fget_image("clos.img", clos);
	fget_image("mine.img", mark);
	fget_image("open.img", opn[0]);
	fget_image("opn1.img", opn[1]);
	fget_image("opn2.img", opn[2]);
	fget_image("opn3.img", opn[3]);
	fget_image("opn4.img", opn[4]);
	fget_image("opn5.img", opn[5]);
	fget_image("opn6.img", opn[6]);
	fget_image("opn7.img", opn[7]);
	fget_image("opn8.img", opn[8]);
	fget_image("opencurs.img", opencurs);
	fget_image("closcurs.img", closcurs);
	fget_image("nomine.img", nomine);
	fget_image("oops.img", oops);
	randomize();
	char headline[20] = "Main Menu", listing[100] = "1. Start Game\x002. Choose Mode\x003. Redefine Key\x004. View High Scores\x005. Quit", keys[10]="12345";
	char mode_head[20] = "Choose Your Mode", mode_listing[200], mode_keys[12], ch[2];
	while((a=menu(5, headline, listing, keys)) != '6')
		switch (a)
		{
			case '1':
				mines_game(X,Y,N);
				break;
			case '2':
				write_mode_menus(mode_listing);
				for(b=0;b<modes_N;b++)
				  mode_keys[b] = '0'+(b+1)%10;
				mode_keys[b+1] = 'n';mode_keys[b+2] = 'd';
				b = menu(modes_N+2, mode_head, mode_listing, mode_keys);
				if ((b>='0')&&(b<'0'+modes_N-1))
					curmode = b-'0'-1+(b=='0')*10;
				else if (b=='n')
				{
					if (modes_N!=10)
					{
						cleardevice();
						moveto(0,10);
						outtext("Please enter the number of columns - \n\t");
						b = ch[1] = 0;
						while((ch[0] = getch())!=13)
						{
							if (('0'<ch[0])&&(ch[0]<'9'))
								b=b*10+(ch[0]-'0');
								outtext(ch);
							//else
								// beep
						}
						if (b<=maxX) modes[modes_N][0] = b;
						else {
							outtext("Illegal number!");
							continue; }
						outtext("Please enter the number of rows - \n\t");
						b = 0;
						while((ch[0] = getch())!=13)
						{
							if (('0'<ch[0])&&(ch[0]<'9'))
								b=b*10+(ch[0]-'0');
								outtext(ch);
							//else
								// beep
						}
						if (b<=maxY) modes[modes_N][1] = b;
						else {
							outtext("Illegal number!");
							modes[modes_N][0] = 0;
							continue; }
						outtext("Please enter the number of mines - \n");
						b = ch[1] = 0;
						while((ch[0] = getch())!=13)
						{
							if (('0'<ch[0])&&(ch[0]<'9'))
								b=b*10+(ch[0]-'0');
								outtext(ch);
							//else
								// beep
						}
						if (b<=maxNmines) modes[modes_N][2] = b;
						else {
							outtext("Illegal number!");
							modes[modes_N][0] = 0;
							continue; }
						modes_N++;
					}
					else {
						cleardevice();
						outtextxy(0,10,"All modes are full!\nDelete a mode if you wish to create a new one!");
						continue;
					}
				}
				else if (b == 'd')
				{
					cleardevice();
					moveto(0,10);
					outtext("Press the number which corresponds\nto the mode you wish to delete-");
					while (((ch[0] = getch())>'9')||(ch[0]<'0')) ;
					ch[0] = ch[0]-'0'-1+(ch[0]=='0')*10;
					if (ch[0]>=modes_N)
					{
						outtext("\n\nNo such mode exist!");
						getch();
						continue;
					}
					else
					{
						for (b=ch[0];b<modes_N;b++)
						{
							modes[b][0] = modes[b+1][0];
							modes[b][1] = modes[b+1][1];
							modes[b][2] = modes[b+1][2];
						}
					}
				}
			break;
			//case '3':
//			case '4':
//				high_scores(curmode);
			/*(case '5':
				cleardevice();
				moveto(20,200);
				outtext("Are you sure you want to quit? (y/n)");
				do ch[0] = getch();
				while ((ch[0] != 'y')&&(ch[0]!='n')&&(ch[0]!='Y')&&(ch[0]!='y'))
				if ((ch[0] == 'n') || (ch[0] == 'y'))
					a++;*/
		}
	closegraph();
	cout << "\nThank you for playing Ohadi Lipski's Mines.\n\n"
	"P.S: This is just the first version. I hope to improve the game later on, so stay\n"
	"tuned for next versions.\n\n"
	"Note:\nThis game is a freeware. You may freely distribute it, without any\n"
	"restrictions. Bye!";
	return 0;
}